bisect--helper: `bisect_reset` shell function in C
[git/git.git] / git-bisect.sh
CommitLineData
8cc6a083 1#!/bin/sh
d025524d 2
dbc349bb 3USAGE='[help|start|bad|good|new|old|terms|skip|next|reset|visualize|view|replay|log|run]'
243a60fb 4LONG_USAGE='git bisect help
6021be86 5 print this long help message.
06e6a745
MM
6git bisect start [--term-{old,good}=<term> --term-{new,bad}=<term>]
7 [--no-checkout] [<bad> [<good>...]] [--] [<pathspec>...]
6021be86 8 reset bisect state and start bisection.
21e5cfd8
AD
9git bisect (bad|new) [<rev>]
10 mark <rev> a known-bad revision/
11 a revision after change in a given property.
12git bisect (good|old) [<rev>...]
13 mark <rev>... known-good revisions/
14 revisions before change in a given property.
21b55e33
MM
15git bisect terms [--term-good | --term-bad]
16 show the terms used for old and new commits (default: bad, good)
5413812f 17git bisect skip [(<rev>|<range>)...]
6021be86 18 mark <rev>... untestable revisions.
38a47fd6 19git bisect next
6021be86 20 find next bisection to test and check it out.
6b87ce23 21git bisect reset [<commit>]
6021be86 22 finish bisection search and go back to commit.
dbc349bb 23git bisect (visualize|view)
6021be86 24 show bisect status in gitk.
38a47fd6 25git bisect replay <logfile>
6021be86 26 replay bisection log.
38a47fd6 27git bisect log
6021be86 28 show bisect log.
38a47fd6 29git bisect run <cmd>...
6021be86 30 use <cmd>... to automatically bisect.
243a60fb
CC
31
32Please use "git help bisect" to get the full man page.'
d025524d 33
8f321a39 34OPTIONS_SPEC=
ae2b0f15 35. git-sh-setup
8cc6a083 36
ce32660e
JS
37_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
38_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
43f9d9f3
AD
39TERM_BAD=bad
40TERM_GOOD=good
ce32660e 41
4796e823
JS
42bisect_head()
43{
44 if test -f "$GIT_DIR/BISECT_HEAD"
45 then
46 echo BISECT_HEAD
47 else
48 echo HEAD
49 fi
50}
51
8cc6a083 52bisect_autostart() {
823ea121 53 test -s "$GIT_DIR/BISECT_START" || {
3145b1a2 54 gettextln "You need to start by \"git bisect start\"" >&2
8cc6a083
LT
55 if test -t 0
56 then
04de0996
ÆAB
57 # TRANSLATORS: Make sure to include [Y] and [n] in your
58 # translation. The program will only accept English input
59 # at this point.
6021be86 60 gettext "Do you want me to do it for you [Y/n]? " >&2
8cc6a083
LT
61 read yesno
62 case "$yesno" in
63 [Nn]*)
64 exit ;;
65 esac
66 bisect_start
67 else
68 exit 1
69 fi
70 }
71}
72
73bisect_start() {
4764f464
JS
74 #
75 # Check for one bad and then some good revisions.
76 #
77 has_double_dash=0
78 for arg; do
6021be86 79 case "$arg" in --) has_double_dash=1; break ;; esac
4764f464
JS
80 done
81 orig_args=$(git rev-parse --sq-quote "$@")
82 bad_seen=0
83 eval=''
cb46d630 84 must_write_terms=0
4a6ada32 85 revs=''
24c51280
JS
86 if test "z$(git rev-parse --is-bare-repository)" != zfalse
87 then
88 mode=--no-checkout
89 else
90 mode=''
91 fi
4764f464 92 while [ $# -gt 0 ]; do
6021be86
JS
93 arg="$1"
94 case "$arg" in
95 --)
96 shift
97 break
4764f464 98 ;;
6021be86
JS
99 --no-checkout)
100 mode=--no-checkout
101 shift ;;
06e6a745
MM
102 --term-good|--term-old)
103 shift
104 must_write_terms=1
105 TERM_GOOD=$1
106 shift ;;
107 --term-good=*|--term-old=*)
108 must_write_terms=1
109 TERM_GOOD=${1#*=}
110 shift ;;
111 --term-bad|--term-new)
112 shift
113 must_write_terms=1
114 TERM_BAD=$1
115 shift ;;
116 --term-bad=*|--term-new=*)
117 must_write_terms=1
118 TERM_BAD=${1#*=}
119 shift ;;
6021be86
JS
120 --*)
121 die "$(eval_gettext "unrecognised option: '\$arg'")" ;;
122 *)
123 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
43b8ff4b
JH
124 test $has_double_dash -eq 1 &&
125 die "$(eval_gettext "'\$arg' does not appear to be a valid revision")"
126 break
6021be86 127 }
4a6ada32 128 revs="$revs $rev"
6021be86
JS
129 shift
130 ;;
4764f464 131 esac
4764f464
JS
132 done
133
4a6ada32
MM
134 for rev in $revs
135 do
136 # The user ran "git bisect start <sha1>
137 # <sha1>", hence did not explicitly specify
138 # the terms, but we are already starting to
139 # set references named with the default terms,
140 # and won't be able to change afterwards.
141 must_write_terms=1
142
143 case $bad_seen in
144 0) state=$TERM_BAD ; bad_seen=1 ;;
145 *) state=$TERM_GOOD ;;
146 esac
147 eval="$eval bisect_write '$state' '$rev' 'nolog' &&"
148 done
8cc6a083 149 #
634f2464 150 # Verify HEAD.
8cc6a083 151 #
48949a18 152 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
ce32660e 153 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
9570fc1e 154 die "$(gettext "Bad HEAD - I need a HEAD")"
634f2464 155
ee831f7d 156 #
634f2464 157 # Check if we are bisecting.
ee831f7d 158 #
d3e54c88 159 start_head=''
634f2464
CC
160 if test -s "$GIT_DIR/BISECT_START"
161 then
162 # Reset to the rev from where we started.
9d0cd91c 163 start_head=$(cat "$GIT_DIR/BISECT_START")
4796e823
JS
164 if test "z$mode" != "z--no-checkout"
165 then
1acf1171 166 git checkout "$start_head" -- ||
9c9b4f2f 167 die "$(eval_gettext "Checking out '\$start_head' failed. Try 'git bisect reset <valid-branch>'.")"
4796e823 168 fi
634f2464
CC
169 else
170 # Get rev from where we start.
171 case "$head" in
172 refs/heads/*|$_x40)
173 # This error message should only be triggered by
174 # cogito usage, and cogito users should understand
175 # it relates to cg-seek.
176 [ -s "$GIT_DIR/head-name" ] &&
382d20e3 177 die "$(gettext "won't bisect on cg-seek'ed tree")"
634f2464
CC
178 start_head="${head#refs/heads/}"
179 ;;
180 *)
9570fc1e 181 die "$(gettext "Bad HEAD - strange symbolic ref")"
634f2464
CC
182 ;;
183 esac
184 fi
8cc6a083
LT
185
186 #
634f2464 187 # Get rid of any old bisect state.
8cc6a083 188 #
fb71a329 189 git bisect--helper --bisect-clean-state || exit
38a47fd6 190
ba963de8
CC
191 #
192 # Change state.
193 # In case of mistaken revs or checkout error, or signals received,
194 # "bisect_auto_next" below may exit or misbehave.
195 # We have to trap this to be able to clean up using
196 # "bisect_clean_state".
197 #
fb71a329 198 trap 'git bisect--helper --bisect-clean-state' 0
ba963de8
CC
199 trap 'exit 255' 1 2 3 15
200
201 #
202 # Write new start state.
203 #
4796e823
JS
204 echo "$start_head" >"$GIT_DIR/BISECT_START" && {
205 test "z$mode" != "z--no-checkout" ||
206 git update-ref --no-deref BISECT_HEAD "$start_head"
207 } &&
de52f5a8 208 git rev-parse --sq-quote "$@" >"$GIT_DIR/BISECT_NAMES" &&
6ba7acff 209 eval "$eval true" &&
cb46d630
AD
210 if test $must_write_terms -eq 1
211 then
ecb3f373 212 git bisect--helper --write-terms "$TERM_BAD" "$TERM_GOOD" || exit
cb46d630 213 fi &&
6c98c054 214 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
ba963de8
CC
215 #
216 # Check if we can proceed to the next bisect state.
217 #
38a47fd6 218 bisect_auto_next
ba963de8
CC
219
220 trap '-' 0
8cc6a083
LT
221}
222
55624f9a
CC
223bisect_write() {
224 state="$1"
225 rev="$2"
737c74ee 226 nolog="$3"
55624f9a 227 case "$state" in
43f9d9f3
AD
228 "$TERM_BAD")
229 tag="$state" ;;
230 "$TERM_GOOD"|skip)
231 tag="$state"-"$rev" ;;
232 *)
233 die "$(eval_gettext "Bad bisect_write argument: \$state")" ;;
55624f9a 234 esac
ba963de8 235 git update-ref "refs/bisect/$tag" "$rev" || exit
f454cdc4 236 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
6c98c054 237 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
55624f9a
CC
238}
239
ee2314f5 240bisect_skip() {
6021be86 241 all=''
ee2314f5
CC
242 for arg in "$@"
243 do
6021be86
JS
244 case "$arg" in
245 *..*)
246 revs=$(git rev-list "$arg") || die "$(eval_gettext "Bad rev input: \$arg")" ;;
247 *)
248 revs=$(git rev-parse --sq-quote "$arg") ;;
249 esac
250 all="$all $revs"
251 done
252 eval bisect_state 'skip' $all
ee2314f5
CC
253}
254
155fc795 255bisect_state() {
8cc6a083 256 bisect_autostart
155fc795 257 state=$1
cb46d630 258 check_and_set_terms $state
155fc795
CC
259 case "$#,$state" in
260 0,*)
f813fb41 261 die "Please call 'bisect_state' with at least one argument." ;;
43f9d9f3 262 1,"$TERM_BAD"|1,"$TERM_GOOD"|1,skip)
57984dd9
VA
263 bisected_head=$(bisect_head)
264 rev=$(git rev-parse --verify "$bisected_head") ||
265 die "$(eval_gettext "Bad rev input: \$bisected_head")"
c9c4e2d5 266 bisect_write "$state" "$rev"
b903674b 267 git bisect--helper --check-expected-revs "$rev" ;;
43f9d9f3 268 2,"$TERM_BAD"|*,"$TERM_GOOD"|*,skip)
155fc795 269 shift
6bc02d56 270 hash_list=''
e3389075 271 for rev in "$@"
155fc795 272 do
a179a303 273 sha=$(git rev-parse --verify "$rev^{commit}") ||
15eaa049 274 die "$(eval_gettext "Bad rev input: \$rev")"
6bc02d56 275 hash_list="$hash_list $sha"
d3e54c88 276 done
6bc02d56
CC
277 for rev in $hash_list
278 do
279 bisect_write "$state" "$rev"
280 done
b903674b 281 git bisect--helper --check-expected-revs $hash_list ;;
43f9d9f3
AD
282 *,"$TERM_BAD")
283 die "$(eval_gettext "'git bisect \$TERM_BAD' can take only one argument.")" ;;
cc9f24d0
JH
284 *)
285 usage ;;
8cc6a083 286 esac
97e1c51e
CC
287 bisect_auto_next
288}
289
8cc6a083 290bisect_next_check() {
0a5280a9 291 missing_good= missing_bad=
43f9d9f3
AD
292 git show-ref -q --verify refs/bisect/$TERM_BAD || missing_bad=t
293 test -n "$(git for-each-ref "refs/bisect/$TERM_GOOD-*")" || missing_good=t
6fecf191 294
0a5280a9
JH
295 case "$missing_good,$missing_bad,$1" in
296 ,,*)
43f9d9f3 297 : have both $TERM_GOOD and $TERM_BAD - ok
0a5280a9
JH
298 ;;
299 *,)
300 # do not have both but not asked to fail - just report.
301 false
302 ;;
43f9d9f3 303 t,,"$TERM_GOOD")
21e5cfd8 304 # have bad (or new) but not good (or old). we could bisect although
0a5280a9 305 # this is less optimum.
43f9d9f3 306 eval_gettextln "Warning: bisecting only with a \$TERM_BAD commit." >&2
0a5280a9
JH
307 if test -t 0
308 then
04de0996
ÆAB
309 # TRANSLATORS: Make sure to include [Y] and [n] in your
310 # translation. The program will only accept English input
311 # at this point.
312 gettext "Are you sure [Y/n]? " >&2
e5d3afd7
FM
313 read yesno
314 case "$yesno" in [Nn]*) exit 1 ;; esac
0a5280a9 315 fi
43f9d9f3 316 : bisect without $TERM_GOOD...
0a5280a9 317 ;;
8cc6a083 318 *)
cb46d630
AD
319 bad_syn=$(bisect_voc bad)
320 good_syn=$(bisect_voc good)
be508d3a
ÆAB
321 if test -s "$GIT_DIR/BISECT_START"
322 then
cb46d630
AD
323
324 eval_gettextln "You need to give me at least one \$bad_syn and one \$good_syn revision.
325(You can use \"git bisect \$bad_syn\" and \"git bisect \$good_syn\" for that.)" >&2
be508d3a 326 else
cb46d630
AD
327 eval_gettextln "You need to start by \"git bisect start\".
328You then need to give me at least one \$good_syn and one \$bad_syn revision.
329(You can use \"git bisect \$bad_syn\" and \"git bisect \$good_syn\" for that.)" >&2
be508d3a 330 fi
0a5280a9 331 exit 1 ;;
8cc6a083
LT
332 esac
333}
334
335bisect_auto_next() {
434d036f 336 bisect_next_check && bisect_next || :
8cc6a083
LT
337}
338
339bisect_next() {
8fe26f44 340 case "$#" in 0) ;; *) usage ;; esac
8cc6a083 341 bisect_autostart
43f9d9f3 342 bisect_next_check $TERM_GOOD
0a5280a9 343
0871984d 344 # Perform all bisection computation, display and checkout
4796e823 345 git bisect--helper --next-all $(test -f "$GIT_DIR/BISECT_HEAD" && echo --no-checkout)
5a1d31c7 346 res=$?
0a5280a9 347
6021be86 348 # Check if we should exit because bisection is finished
a7f8b8ac
TH
349 if test $res -eq 10
350 then
43f9d9f3 351 bad_rev=$(git show-ref --hash --verify refs/bisect/$TERM_BAD)
a7f8b8ac 352 bad_commit=$(git show-branch $bad_rev)
43f9d9f3 353 echo "# first $TERM_BAD commit: $bad_commit" >>"$GIT_DIR/BISECT_LOG"
a7f8b8ac 354 exit 0
f989cac9
TH
355 elif test $res -eq 2
356 then
357 echo "# only skipped commits left to test" >>"$GIT_DIR/BISECT_LOG"
43f9d9f3
AD
358 good_revs=$(git for-each-ref --format="%(objectname)" "refs/bisect/$TERM_GOOD-*")
359 for skipped in $(git rev-list refs/bisect/$TERM_BAD --not $good_revs)
f989cac9
TH
360 do
361 skipped_commit=$(git show-branch $skipped)
43f9d9f3 362 echo "# possible first $TERM_BAD commit: $skipped_commit" >>"$GIT_DIR/BISECT_LOG"
f989cac9
TH
363 done
364 exit $res
a7f8b8ac 365 fi
0a5280a9 366
5a1d31c7
CC
367 # Check for an error in the bisection process
368 test $res -ne 0 && exit $res
369
370 return 0
8cc6a083
LT
371}
372
cc9f24d0
JH
373bisect_visualize() {
374 bisect_next_check fail
235997c9
JH
375
376 if test $# = 0
377 then
c4e4644e 378 if test -n "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" &&
43b8ff4b 379 type gitk >/dev/null 2>&1
eef12a9a 380 then
c4e4644e
JK
381 set gitk
382 else
383 set git log
384 fi
235997c9
JH
385 else
386 case "$1" in
387 git*|tig) ;;
388 -*) set git log "$@" ;;
389 *) set git "$@" ;;
390 esac
391 fi
392
fc13aa3d 393 eval '"$@"' --bisect -- $(cat "$GIT_DIR/BISECT_NAMES")
cc9f24d0
JH
394}
395
e204de28 396bisect_replay () {
55a9fc80
ÆAB
397 file="$1"
398 test "$#" -eq 1 || die "$(gettext "No logfile given")"
399 test -r "$file" || die "$(eval_gettext "cannot read \$file for replaying")"
5e82c3dd 400 git bisect--helper --bisect-reset || exit
6c98c054 401 while read git bisect command rev
e204de28 402 do
c82af12a 403 test "$git $bisect" = "git bisect" || test "$git" = "git-bisect" || continue
eef12a9a
JS
404 if test "$git" = "git-bisect"
405 then
6c98c054
MV
406 rev="$command"
407 command="$bisect"
408 fi
cb46d630
AD
409 get_terms
410 check_and_set_terms "$command"
e204de28
JH
411 case "$command" in
412 start)
e9a45d75 413 cmd="bisect_start $rev"
737c74ee 414 eval "$cmd" ;;
cb46d630 415 "$TERM_GOOD"|"$TERM_BAD"|skip)
737c74ee 416 bisect_write "$command" "$rev" ;;
21b55e33
MM
417 terms)
418 bisect_terms $rev ;;
e204de28 419 *)
9570fc1e 420 die "$(gettext "?? what are you talking about?")" ;;
e204de28 421 esac
55a9fc80 422 done <"$file"
e204de28 423 bisect_auto_next
8cc6a083
LT
424}
425
a17c4101 426bisect_run () {
6021be86
JS
427 bisect_next_check fail
428
fecd2dd3
SB
429 test -n "$*" || die "$(gettext "bisect run failed: no command provided.")"
430
6021be86
JS
431 while true
432 do
433 command="$@"
3145b1a2 434 eval_gettextln "running \$command"
6021be86
JS
435 "$@"
436 res=$?
437
438 # Check for really bad run error.
eef12a9a
JS
439 if [ $res -lt 0 -o $res -ge 128 ]
440 then
3145b1a2
JS
441 eval_gettextln "bisect run failed:
442exit code \$res from '\$command' is < 0 or >= 128" >&2
6021be86
JS
443 exit $res
444 fi
445
446 # Find current state depending on run success or failure.
447 # A special exit code of 125 means cannot test.
eef12a9a
JS
448 if [ $res -eq 125 ]
449 then
6021be86 450 state='skip'
eef12a9a
JS
451 elif [ $res -gt 0 ]
452 then
43f9d9f3 453 state="$TERM_BAD"
6021be86 454 else
43f9d9f3 455 state="$TERM_GOOD"
6021be86
JS
456 fi
457
458 # We have to use a subshell because "bisect_state" can exit.
305a233c 459 ( bisect_state $state >"$GIT_DIR/BISECT_RUN" )
6021be86
JS
460 res=$?
461
462 cat "$GIT_DIR/BISECT_RUN"
463
43f9d9f3 464 if sane_grep "first $TERM_BAD commit could be any of" "$GIT_DIR/BISECT_RUN" \
305a233c 465 >/dev/null
eef12a9a 466 then
3145b1a2 467 gettextln "bisect run cannot continue any more" >&2
6021be86
JS
468 exit $res
469 fi
470
eef12a9a
JS
471 if [ $res -ne 0 ]
472 then
3145b1a2
JS
473 eval_gettextln "bisect run failed:
474'bisect_state \$state' exited with error code \$res" >&2
6021be86
JS
475 exit $res
476 fi
a17c4101 477
43f9d9f3 478 if sane_grep "is the first $TERM_BAD commit" "$GIT_DIR/BISECT_RUN" >/dev/null
eef12a9a 479 then
3145b1a2 480 gettextln "bisect run success"
6021be86
JS
481 exit 0;
482 fi
a17c4101 483
6021be86 484 done
a17c4101
CC
485}
486
412ff738 487bisect_log () {
9570fc1e 488 test -s "$GIT_DIR/BISECT_LOG" || die "$(gettext "We are not bisecting.")"
412ff738
SG
489 cat "$GIT_DIR/BISECT_LOG"
490}
a17c4101 491
cb46d630
AD
492get_terms () {
493 if test -s "$GIT_DIR/BISECT_TERMS"
494 then
495 {
496 read TERM_BAD
497 read TERM_GOOD
498 } <"$GIT_DIR/BISECT_TERMS"
499 fi
500}
501
cb46d630
AD
502check_and_set_terms () {
503 cmd="$1"
504 case "$cmd" in
505 skip|start|terms) ;;
506 *)
507 if test -s "$GIT_DIR/BISECT_TERMS" && test "$cmd" != "$TERM_BAD" && test "$cmd" != "$TERM_GOOD"
508 then
509 die "$(eval_gettext "Invalid command: you're currently in a \$TERM_BAD/\$TERM_GOOD bisect.")"
510 fi
511 case "$cmd" in
512 bad|good)
513 if ! test -s "$GIT_DIR/BISECT_TERMS"
514 then
ecb3f373
PB
515 TERM_BAD=bad
516 TERM_GOOD=good
517 git bisect--helper --write-terms "$TERM_BAD" "$TERM_GOOD" || exit
cb46d630
AD
518 fi
519 ;;
21e5cfd8
AD
520 new|old)
521 if ! test -s "$GIT_DIR/BISECT_TERMS"
522 then
ecb3f373
PB
523 TERM_BAD=new
524 TERM_GOOD=old
525 git bisect--helper --write-terms "$TERM_BAD" "$TERM_GOOD" || exit
21e5cfd8
AD
526 fi
527 ;;
cb46d630
AD
528 esac ;;
529 esac
530}
531
532bisect_voc () {
533 case "$1" in
21e5cfd8
AD
534 bad) echo "bad|new" ;;
535 good) echo "good|old" ;;
cb46d630
AD
536 esac
537}
538
21b55e33
MM
539bisect_terms () {
540 get_terms
541 if ! test -s "$GIT_DIR/BISECT_TERMS"
542 then
543 die "$(gettext "no terms defined")"
544 fi
545 case "$#" in
546 0)
547 gettextln "Your current terms are $TERM_GOOD for the old state
548and $TERM_BAD for the new state."
549 ;;
550 1)
551 arg=$1
552 case "$arg" in
553 --term-good|--term-old)
554 printf '%s\n' "$TERM_GOOD"
555 ;;
556 --term-bad|--term-new)
557 printf '%s\n' "$TERM_BAD"
558 ;;
559 *)
560 die "$(eval_gettext "invalid argument \$arg for 'git bisect terms'.
561Supported options are: --term-good|--term-old and --term-bad|--term-new.")"
562 ;;
563 esac
564 ;;
565 *)
566 usage ;;
567 esac
568}
569
8cc6a083
LT
570case "$#" in
5710)
6021be86 572 usage ;;
8cc6a083 573*)
6021be86 574 cmd="$1"
cb46d630 575 get_terms
6021be86
JS
576 shift
577 case "$cmd" in
578 help)
579 git bisect -h ;;
580 start)
581 bisect_start "$@" ;;
21e5cfd8 582 bad|good|new|old|"$TERM_BAD"|"$TERM_GOOD")
6021be86
JS
583 bisect_state "$cmd" "$@" ;;
584 skip)
585 bisect_skip "$@" ;;
586 next)
587 # Not sure we want "next" at the UI level anymore.
588 bisect_next "$@" ;;
589 visualize|view)
590 bisect_visualize "$@" ;;
591 reset)
5e82c3dd 592 git bisect--helper --bisect-reset "$@" ;;
6021be86
JS
593 replay)
594 bisect_replay "$@" ;;
595 log)
596 bisect_log ;;
597 run)
598 bisect_run "$@" ;;
21b55e33
MM
599 terms)
600 bisect_terms "$@" ;;
6021be86
JS
601 *)
602 usage ;;
603 esac
8cc6a083 604esac